#include "Year.h"

Year::Year()
	:YearNum(1){
	for(int i=0;i<12;++i){
		months[i] = new Month();		
	}
	setIsLeapYear();
	set_1stDaysOfWeek();
	setEachMonth();
}
Year::Year(int YearNum){
	if(YearNum < 1 || YearNum > 10000){
		cout << "⵵ Է°  ϴ." << endl;
		exit(0);
	} else {
		for(int i=0;i<12;++i){
			months[i] = new Month();
		}	
		setIsLeapYear();
		set_1stDaysOfWeek();
		setEachMonth();
	}
}
void Year::setIsLeapYear(){
	if((YearNum % 4 == 0) && (YearNum % 100 != 0) || (YearNum % 400 == 0))
		this->isLeapYear = true;
}
void Year::set_1stDaysOfWeek(){				
	int LeapYearAmount = 0;								//⵵  
	int temp;											//⵵   ϼ   ӽ 

	LeapYearAmount = (YearNum - 1) / 4;
	LeapYearAmount -= ((YearNum - 1) / 100);
	LeapYearAmount += ((YearNum - 1) / 400);

	temp = (YearNum-1) * 365;
	temp += LeapYearAmount;								//⿡   ¥
	
	switch(temp%7){
	case 0:
		_1stDay = SUNDAY;
		break;
	case 1:
		_1stDay = MONDAY;
		break;
	case 2:
		_1stDay = TUESEDAY;
		break;
	case 3:
		_1stDay = WEDNESDAY;
		break;
	case 4:
		_1stDay = THURSDAY;
		break;
	case 5:
		_1stDay = FRIDAY;
		break;
	case 6:
		_1stDay = SATURDAY;
		break;
	}
}
void Year::setEachMonth(){
	for(int i=1;i<=12;++i){												// ڿ   ϼ 
		months[i]->setMonthNum(i);											//  
		if(i == 2){															//2  ó									
			if(isLeapYear)														// 
				months[2]->setDaysOfMonth(29);	
			else																// ƴ 
				months[2]->setDaysOfMonth(28);
		} else if(i == 4 || i == 6 || i == 9 || i == 11){					//30ϱ ִ ޵ ó
			months[i]->setDaysOfMonth(30);
		} else{																//31ϱ ִ ޵ ó
			months[i]->setDaysOfMonth(31);
		}
	}

	for(int i=1;i<=12;++i){												//   
		if(i == 1)															//1  ó
			months[1]->set_1stDay(_1stDay);				
		else{																
			int temp = _1stDay;
			temp += (months[i-1]->getDaysOfMonth()) % 7;
			if(temp > 6)
				temp %= 7;

			switch(temp){
			case 0:
				months[i]->set_1stDay(SUNDAY);
				break;
			case 1:
				months[i]->set_1stDay(MONDAY);
				break;
			case 2:
				months[i]->set_1stDay(TUESEDAY);
				break;
			case 3:
				months[i]->set_1stDay(WEDNESDAY);
				break;
			case 4:
				months[i]->set_1stDay(THURSDAY);
				break;
			case 5:
				months[i]->set_1stDay(FRIDAY);
				break;
			case 6:
				months[i]->set_1stDay(SATURDAY);
				break;
			}			
		}
	}
}
Month Year::operator[](int MonthNum) const{
	if(MonthNum >= 1 && MonthNum <= 12)
		return *(months[MonthNum-1]);
	else{
		cout << "ش ⵵    Ѿϴ." << endl;
		exit(0);
	}
}
Year::~Year(){
	delete []months;
}